#include <sys/ioctl.h>
#include <linux/spi/spidev.h>
#include <fcntl.h>
#include <cstring>
#include <iostream>
#include <unistd.h>

using namespace std;

int fd;
#define BUFF 4096

unsigned char data[BUFF] = {0};
unsigned int result;

int spiTxRx(unsigned char txDat);
int spiRx(void);
void spiTx(unsigned char txDat);

void Txfunc(void) {
	struct spi_ioc_transfer spi;
	for (int i=0, var=0; i<BUFF; i++){
		data[i] = var;
		var++;
		if (var==100)
			var = 0;
	}
	data[BUFF-1] = 250;
	memset (&spi, 0, sizeof (spi));
	spi.tx_buf        = (unsigned long)data;
	spi.len           = BUFF;

	ioctl (fd, SPI_IOC_MESSAGE(1), &spi);
}

int main (void) {
	fd = open("/dev/spidev0.0", O_RDWR);
	unsigned int speed = 2000000;
	
	ioctl (fd, SPI_IOC_WR_MAX_SPEED_HZ, &speed);
	
	Txfunc();
}

int spiTxRx(unsigned char txDat) {
	unsigned char rxDat;

	struct spi_ioc_transfer spi;

	memset (&spi, 0, sizeof (spi));

	spi.tx_buf        = (unsigned long)&txDat;
	spi.rx_buf        = (unsigned long)&rxDat;
	spi.len           = 1;

	ioctl (fd, SPI_IOC_MESSAGE(1), &spi);

	return rxDat;
}

void spiTx(unsigned char txDat) {
	struct spi_ioc_transfer spi;

	memset (&spi, 0, sizeof (spi));
	spi.tx_buf        = (unsigned long)&txDat;
	spi.len           = 1;

	ioctl (fd, SPI_IOC_MESSAGE(1), &spi);
}

int spiRx() {
	unsigned char rxDat;

	struct spi_ioc_transfer spi;

	memset (&spi, 0, sizeof (spi));

	spi.rx_buf        = (unsigned long)&rxDat;
	spi.len           = 1;

	ioctl (fd, SPI_IOC_MESSAGE(1), &spi);

	return rxDat;
}
